export declare type Charset = 'utf8' | 'utf8mb4';
export declare type DatabaseMetadata = {
    name: string;
    user: string;
    password: string;
    host: string | {
        domain: string;
        port: number;
    };
    dialect?: string;
    charset?: Charset;
    pool?: {
        max?: number;
        min?: number;
        idle?: number;
    };
};
export declare type OrmMetadata = {
    enabled?: boolean;
    db?: DatabaseMetadata;
    recreate?: boolean;
};
