import { Server } from '../../server/server';
import { CtorT } from '../../core/ctor';
import { StaticModelT, ModelT, PkType } from '../../core/model';
import { ServiceT } from '../../core/service';
import { OrmMetadata } from '../orm/orm';
import { ProvideMetadata } from './provide';
import { LogLevel } from './server';
export declare type Task = (server: Server, ...args: string[]) => Promise<void>;
export declare type TaskMetadata = {
    task: Task;
    name?: string;
    orm?: OrmMetadata;
    inject?: ProvideMetadata<any>[];
    models?: StaticModelT<ModelT<PkType>>[];
    services?: CtorT<ServiceT>[];
    logLevel?: LogLevel | {
        [name: string]: LogLevel;
    };
};
