import 'reflect-metadata';
import { StaticModelT, ModelT, PkType } from '../core/model';
import { Transaction } from '../core/transaction';
import { Server } from '../server/server';
export declare class OrmReflector {
    private server;
    constructor(server: Server);
    private readonly logger;
    private ormTransform;
    private sql;
    init(): Promise<void>;
    sync(recreate?: boolean): Promise<any>;
    transaction(transaction?: Transaction): Promise<Transaction>;
    reflectModels(models: StaticModelT<ModelT<PkType>>[]): void;
    private models;
    private modelsByTableName;
    reflectModel(modelFn: StaticModelT<ModelT<PkType>>): void;
    private reflectAssociations(models);
    private reflectModelAssociations(modelFn);
    private createDbImpls(models);
    private isStaticModelT(test);
    private isTableNameRef(test);
    private isModelNameRef(test);
    private resolveForeignModelFn(meta);
}
