/// <reference types="express" />
import * as express from 'express';
import { Injector } from '../core/injector';
import { Transaction } from '../core/transaction';
import { ServerMetadata } from '../metadata/server/server';
import { Logger } from '../services/logger';
export declare class Server {
    private _meta;
    constructor(_meta: ServerMetadata);
    private _logger;
    readonly logger: Logger;
    private _app;
    readonly app: express.Application;
    private _injector;
    readonly injector: Injector;
    readonly meta: ServerMetadata;
    init(): Promise<void>;
    errorCode: number;
    shutdown(): Promise<void>;
    createExpressApp(): void;
    private ormReflector;
    reflectOrm(): Promise<void>;
    transaction(transaction?: Transaction): Promise<Transaction>;
    private serviceReflector;
    private startServices();
    private stopServices();
    private routerReflector;
    private reflectRoutes();
    private webServer;
    private listen();
    private stopListening();
    private onError(error);
    private onListening();
}
