"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const readline_1 = require("readline");
const nativeCin = readline_1.createInterface({
    input: process.stdin,
    output: process.stdout
});
let resolveFns = [];
function emitLine(line) {
    if (!resolveFns.length)
        return;
    let resolveFn = resolveFns.splice(0, 1)[0];
    resolveFn(line.trim());
}
nativeCin.on('line', (line) => emitLine(line));
exports.cin = {
    readline: () => {
        return new Promise((resolve, reject) => {
            resolveFns.push(resolve);
            nativeCin.prompt();
        });
    },
    native: nativeCin,
    pause: () => void nativeCin.pause(),
    resume: () => void nativeCin.resume(),
    emit: (line) => emitLine(line)
};
//# sourceMappingURL=cin.js.map